--
-- Table structure for table `logicalreader`
--

DROP TABLE IF EXISTS `logicalreader`;
CREATE TABLE `logicalreader` (
  `logicalreader_id` varchar(30) NOT NULL,
  `suppress` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`logicalreader_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Table structure for table `reader`
--

DROP TABLE IF EXISTS `reader`;
CREATE TABLE `reader` (
  `reader_id` varchar(30) NOT NULL,
  `suppress` tinyint(1) NOT NULL default '0',
  `manufacturer` varchar(30) default NULL,
  `model` varchar(30) default NULL,
  `ipaddress` varchar(30) default NULL,
  PRIMARY KEY  (`reader_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Table structure for table `readermapping`
--

DROP TABLE IF EXISTS `readermapping`;
CREATE TABLE `readermapping` (
  `logicalreader_id` varchar(30) NOT NULL,
  `reader_id` varchar(30) NOT NULL,
  PRIMARY KEY  (`logicalreader_id`,`reader_id`),
  KEY `reader_id` (`reader_id`),
  CONSTRAINT `readermapping_ibfk_1` FOREIGN KEY (`logicalreader_id`) REFERENCES `logicalreader` (`logicalreader_id`) ON DELETE CASCADE,
  CONSTRAINT `readermapping_ibfk_2` FOREIGN KEY (`reader_id`) REFERENCES `reader` (`reader_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

